POJ--Lost Cows (线段树)

题目:http://poj.org/problem?id=2182   
http://acm.hdu.edu.cn/showproblem.php?pid=2711

题意:有N头牛,编号为1--N。 乱序排成一列,已知每头牛前面有多少头牛比它的编号小(从第二头牛开始)。

现在需要求这个序列中从前到后,每一头牛的编号。

思路:因为有N头牛,编号为1--N,最后一头牛如果前面有K头牛比它小,那么可以知道最后这头牛的编号为K+1.

当最后一头牛编号为K+1确定以后,再来看倒数第二头牛,如果这头牛前面有K1头牛比它小,那么这头牛的编号

必然是剩下N-1头牛中第(K1+1)大的。然后以此类推。。。。

最开始的线段树为:

最后一头牛前面有0个比它小,那么这是找第(0+1)大的数。为左下角的(1,1)即1.

倒数第二头牛前面有1个比它小,那么这头牛是剩下所有牛中第(1+1)大的,为(3,3)即3

倒数第三头牛前面有2个比它大,那么这头牛是剩下所有牛中第(2+1)大的,为(5,5)即5.

代码:

#include<cstdio>
#include<cstring>
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
using namespace std;
const int maxn=8010;
int n,arr[maxn],sum[maxn<<2];
int num[maxn];
void build(int l,int r,int rt)
{
	sum[rt]=r-l+1;
	if(l==r) return;
	int m=(l+r)>>1;
	build(lson);
	build(rson);
}
int query(int p,int l,int r,int rt)
{
	sum[rt]--;
	if(l==r) return l;
	int m=(l+r)>>1;
	if(p<=sum[rt<<1]) return query(p,lson);
	else			  return query(p-sum[rt<<1],rson);
}
int main()
{
	while (~scanf("%d",&n))
	{
		build(1,n,1);
		for(int i=2;i<=n;i++) scanf("%d",&arr[i]);
		arr[1]=0;
		for(int i=n;i>0;i--)
			num[i]=query(arr[i]+1,1,n,1);
		for(int i=1;i<=n;i++)
			printf("%d\n",num[i]);
	}
	return 0;
}

POJ--Lost Cows (线段树),布布扣,bubuko.com

时间: 2024-12-01 03:04:55

POJ--Lost Cows (线段树)的相关文章

POJ 2481 Cows (线段树)

Cows 题目:http://poj.org/problem?id=2481 题意:有N头牛,每只牛有一个值[S,E],如果对于牛i和牛j来说,它们的值满足下面的条件则证明牛i比牛j强壮:Si <=Sjand Ej <= Ei and Ei - Si > Ej - Sj.现在已知每一头牛的测验值,要求输出每头牛有几头牛比其强壮. 思路:将牛按照S从小到大排序,S相同按照E从大到小排序,这就保证了排在后面的牛一定不比前面的牛强壮.再按照E值(离散化后)建立一颗线段树(这里最值只有1e5,所

POJ 2182 Lost Cows.(线段树)

~~~~ 数据太水,暴力无压力,不过还是用线段树写了下,表现了楼主对线段树的无限热爱之情. ~~~~ 题目连接:http://poj.org/problem?id=2182 大致题意;牛牛因XXXXXX原因乱序成一排,现已知每头牛前面有多少头牛比它的编号小(第一头牛前面没有当然就不列粗来了),求每头牛的编号. 思路:从后往前扫描,遇到a,则说明它是剩余序列的第a+1头牛. ~~~~ 暴力代码:(157ms) #include<cstdio> #include<algorithm>

poj 2182 Lost Cows(线段树经典题)

题目链接:http://poj.org/problem?id=2182 Lost Cows Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 9152   Accepted: 5879 Description N (2 <= N <= 8,000) cows have unique brands in the range 1..N. In a spectacular display of poor judgment, th

POJ 2299 离散化线段树

点击打开链接 Ultra-QuickSort Time Limit: 7000MS   Memory Limit: 65536K Total Submissions: 40827   Accepted: 14752 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by

POJ训练计划2299_Ultra-QuickSort(线段树/单点更新)

解题报告 题意: 求逆序数. 思路: 线段树离散化处理. #include <algorithm> #include <iostream> #include <cstring> #include <cstdio> #define LL long long using namespace std; LL sum[2001000],num[501000],_hash[501000]; void push_up(int rt) { sum[rt]=sum[rt*2

POJ 3667(线段树区间合并)

http://poj.org/problem?id=3667 题意:两个操作 : 1 选出靠左的长度为a的区间. 2 把从 a到a+b的区间清空. 线段树区间合并+lazy // by caonima // hehe #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #include <cmath> using namespace std; co

POJ&#183;1151 Atlantis&#183;线段树求矩形面积并

题目在这:http://poj.org/problem?id=1151 Atlantis Time Limit: 1000MS   Memory Limit: 10000K Description There are several ancient Greek texts that contain descriptions of the fabled island Atlantis. Some of these texts even include maps of parts of the is

POJ 2299 Ultra-QuickSort(线段树+离散化)

题目地址:POJ 2299 这题曾经用归并排序做过,线段树加上离散化也可以做.一般线段树的话会超时. 这题的数字最大到10^10次方,显然太大,但是可以利用下标,下标总共只有50w.可以从数字大的开始向树上加点,然后统计下标比它小即在它左边的数的个数.因为每加一个数的时候,比该数大的数已经加完了,这时候坐标在它左边的就是一对逆序数. 但是该题还有一个问题,就是数字重复的问题.这时候可以在排序的时候让下标大的在前面,这样就可以保证加点的时候下标比他小的数中不会出现重复的. 这题需要注意的是要用__

poj 2777(线段树的节点更新策略)

1 /* 2 之前的思想是用回溯的方式进行颜色的更新的!如果用回溯的方法的话,就是将每一个节点的颜色都要更新 3 通过子节点的颜色情况来判断父节点的颜色情况 !这就是TLE的原因! 4 5 后来想一想没有必要 !加入[a, b] 区间有p管辖,那么tree[p]的颜色值就是[a, b]所有点的颜色值! 6 如果[a,b]的子区间[c,d]没被跟新,那么tree[p]也是[c,d]的值! 7 否则,在更新[c,d]区间的时候,一定会经过 p 点!然后由上到下更新p<<1 和 p<<1

poj 3468(简单线段树区间更新)

A Simple Problem with Integers Time Limit: 5000MS   Memory Limit: 131072K Total Submissions: 61936   Accepted: 18934 Case Time Limit: 2000MS Description You have N integers, A1, A2, ... , AN. You need to deal with two kinds of operations. One type of